// Zustand der Turtle
boolean penIsDown=true; // Stift is unten (es wird gemalt)

// gloable Variablen: 
// Fenstergröße
int w=1000;
int h=1000;

//----------------------------------------------------------------
// Lindenmayer-Systeme für den Binärbaum
//----------------------------------------------------------------

 //float x0 = 400;
 //float y0 = 700;
 //String axiom = "F";
 //float winkel = 30;
 //float laenge = 30;               // Länge eines Segments in Pixeln
 //int tiefe=3;                     // Anzahl Ersetzungen
//tring[] rules = {"F:=F[+F][-F]"};
// String[] rules = {"F := F[+F]F[-F]F"};
// String[] rules = {"F := F[+F]F[-F][F]"};
// String[] rules = {"F := FF[+F][--FF][-F+F]"};

//----------------------------------------------------------------
// Lindenmayer-Systeme für "Pflanzen"
//----------------------------------------------------------------

 //float x0 = w/2;
 //float y0 = h-10;
 //String axiom = "X";
 //float winkel = 20;
 //float laenge = 10;               
 //int tiefe=3;                     
 //String[] rules = {"X:=F[+X]F[-X]+X","F:=FF"};

 //float x0 = w/2;
 //float y0 = h-10;
 //String axiom = "X";
 //float winkel = 25.7;
 //float laenge = 10;
 //int tiefe=3;
 //String[] rules = {"X:=F[+X][-X]FX","F:=FF"};

 float x0 = w/2;
 float y0 = h-10;
 String axiom = "X";
 float winkel = 22.5;
 float laenge = 10;
 int tiefe=3;
 String[] rules = {"X:=F-[[X]+X]+F[+FX]-X","F:=FF"};

//----------------------------------------------------------------
// Lindenmayer-Systeme für Hilbert-Kurve
//----------------------------------------------------------------

//float x0 = 10;
//float y0 = h-10;
//String axiom = "A";
//float winkel = 90;
//float laenge = 20; 
//int tiefe=3;
//String[] rules = {"A:=-BF+AFA+FB-","B:=+AF-BFB-FA+"};

//----------------------------------------------------------------

String s;

///////////////////////////////////////////////////////////

void settings() {
  size(w, h);
}

void setup() {
  ersetzeBuchstaben();
  //strokeWeight(2);//dickere Linien
  noLoop();
  redraw();
}

///////////////////////////////////////////////////////////
//
// Turtle Kommandos
//
///////////////////////////////////////////////////////////

void move(float len) {
  if (penIsDown) line(0,0,len,0);
  // bewege Turtle weiter
  translate(len,0);
}

void turn(float ang) { rotate(radians(-ang)); }
void setColor(color c) { stroke(c); }
void penUp() { penIsDown = false; }
void penDown() { penIsDown = true; }
void saveState() {  pushMatrix(); }
void restoreState() { popMatrix(); }

//----------------------------------------------------------------
// hier werden im Eingabestring alle Buchstaben, für die eine 
// Regel in "rules" existiert
// durch die rechte Seite der Regel ersetzt
//----------------------------------------------------------------

String wendeRegelnAn(String s) {

  String res = "";
  for (int i=0;i<s.length();i++) {
    char c = s.charAt(i);
    boolean ruleFound = false;
    for (int k=0;k<rules.length; k++) {
      char leftSide = rules[k].charAt(0);
      String rightSide = rules[k].substring(3,rules[k].length());
      if (c == leftSide) {
          ruleFound = true;
          res += rightSide;
          break;
      }
    }
    if (!ruleFound) res += c;
  }  
  return res;
}

//----------------------------------------------------------------
// ähnlich zur Ersetzung durch das Substitut aus den vorangehenden
// Beispielen werden nun die Regeln des Lindemayer-Systems angewendet
//----------------------------------------------------------------

void ersetzeBuchstaben() {
  
  s = axiom;
  for (int i=0; i<tiefe; i++) s = wendeRegelnAn(s);
}

//----------------------------------------------------------------

void draw() {
  background(255);
  stroke(0);
  translate(x0,y0);
  rotate(radians(-90));
  
  for (int i=0;i<s.length();i++) {
    char c = s.charAt(i);
    switch (c) {
      case 'F': move(laenge);
                break;
      case '-': turn(-winkel);
                break;
      case '+': turn(winkel);
                break;
      case '[': saveState();
                break;
      case ']': restoreState();
                break;
    }  
  }
}

//----------------------------------------------------------------

void keyPressed() {
  switch (key) {
    case '+' :
      tiefe = min(10,tiefe+1);
      ersetzeBuchstaben();
      redraw();
      break;
    case '-':
      tiefe = max(1,tiefe-1);
      ersetzeBuchstaben();
      redraw();
      break;
    case 'r':
      laenge *= 0.95;
      redraw();
      break;
    case 'e':
      laenge /= 0.95;
      redraw();
      break;
  }     
}
